import javax.xml.rpc.Call;
import javax.xml.rpc.Service;
import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.ServiceFactory;
import javax.xml.rpc.encoding.XMLType;
import javax.xml.namespace.QName;

public class HelloClient {
    
  public static void main(String args[]) {
    Service service = null;
    Call call = null;
    String ret = null;
    Object callArgs[];
    // WebT[rX̃Gh|Cg(URL)
    String endpoint = args[0];
    try {
      //-----------------(1)----------------
      ServiceFactory factory  = ServiceFactory.newInstance();
      // T[rX̎擾
      service = factory.createService(null);
      // Remote Procedure Call ̐ݒ
      call    = (Call) service.createCall();

      //-----------------(2)----------------
      // Gh|Cg(WebT[rX񋟂ĂURL)̐ݒ
      call.setTargetEndpointAddress(endpoint);

      //-----------------(3)----------------
      // ^CAEgԂ~bŐݒ
      // Őݒ肵ԃT[o烌X|XAėȂꍇA
      // NCAg狭IɃRlNVؒfB
      // (Axisg)
      ((org.apache.axis.client.Call)call).setTimeout(new Integer(30*1000));

      // ZbVǗs悤ɐݒ
      ((org.apache.axis.client.Call)call).setMaintainSession(true);

      if("regist".equals(args[1])){
        //-----------------(4)----------------
        // WebT[rX̃Iy[Vݒ
        call.setOperationName(new QName("regist"));

        // WebT[rX̃Iy[V1Ԗڈ̌^ݒ
        // ł́A^(XMLType.XSD_STRING)w
        call.addParameter( "id", XMLType.XSD_INTEGER, 
     		       ParameterMode.IN );

        // WebT[rX̃Iy[V2Ԗڈ̌^ݒ
        // ł́A^(XMLType.XSD_STRING)w
        call.addParameter( "product", XMLType.XSD_STRING, 
    		         ParameterMode.IN );

        // ԋpľ^ݒ
        call.setReturnType( XMLType.XSD_STRING );

        // Iy[Vs
        callArgs = new Object[] {new Integer(args[2]),args[3]};

        //-----------------(5)----------------
        // WebT[rX̎s
        ret = (String)call.invoke(callArgs);
        System.out.println("regstered("+args[2]+")="+args[3]);
        
        //-----------------(6)----------------
        // CallCX^X̃Iy[ṼNA
        call.removeAllParameters();
      } 
      
      if("regist".equals(args[1]) || "lookup".equals(args[1])){
        //-----------------(4')----------------
        // WebT[rX̃Iy[Vݒ
        call.setOperationName(new QName("lookup"));

        // WebT[rX̃Iy[V1Ԗڈ̌^ݒ
        // ł́A^(XMLType.XSD_STRING)w
        call.addParameter( "id", XMLType.XSD_INTEGER, 
    		         ParameterMode.IN );

        // WebT[rX̃Iy[V2Ԗڈ̌^ݒ
        // ł́A^(XMLType.XSD_STRING)w
        // ԋpľ^ݒ
        call.setReturnType( XMLType.XSD_STRING );

        callArgs = new Object[] {new Integer(args[2])};
        //-----------------(5')----------------
        // WebT[rX̎s
        ret = (String)call.invoke(callArgs);
        System.out.println("lookup("+args[2]+")="+ret);
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
