package samples.catalog;

import java.util.Hashtable;

public class CatalogSoapBindingImpl implements samples.catalog.Catalog_Port {

    private Hashtable catalog = new Hashtable();
    private Hashtable order = new Hashtable();

    public java.lang.String addItemInfo(samples.catalog.Item item)
        throws java.rmi.RemoteException {
        // ----- addItemInfõWbNɋLq ----------------------
        if (catalog.containsKey(item.getItemId()))
            return new String("already registered");
        catalog.put(item.getItemId(), item);
        return new String("successful");
        // --------------------------------------------------------------
    }

    public samples.catalog.Item getItemInfo(java.lang.String itemId)
        throws java.rmi.RemoteException {
        // ----- getItemInfõWbNɋLq ----------------------
        return (samples.catalog.Item) catalog.get(itemId);
        // --------------------------------------------------------------
    }

    public java.lang.String orderItem(java.lang.String itemId, int num) 
        throws java.rmi.RemoteException {
        // ----- orderItem̃WbNɋLq ------------------------
        Integer ordernum = (Integer) order.get(itemId);
        int tmp;
        if (ordernum != null) tmp = ordernum.intValue() + num;
        else tmp = num;
        order.put(itemId, new Integer(tmp));
        return new String("ItemId : " + itemId + "" + num + "");
        // --------------------------------------------------------------
    }
}